#!/bin/sh

# Kindle 4.0.0 Jailbreak
# Created by Yifan Lu
# http://yifan.lu/


# History:
# 2011-12-10 first K4W 4.0.0 release
# 2011-12-11 run at DIAG mode only in dropbear


HACKNAME="jailbreak"
HOME_DIR="/mnt/us"
KEY_DIR=/mnt/main/etc/uks
INIT_DIR="/mnt/main/etc/init.d"
SLEVEL="64"
KLEVEL="09"

_FUNCTIONS=/etc/rc.d/functions
[ -f ${_FUNCTIONS} ] && . ${_FUNCTIONS}

logmsg()
{
    local _NVPAIRS
    local _FREETEXT
    local _MSG_SLLVL
    local _MSG_SLNUM

    _MSG_LEVEL=$1
    _MSG_COMP=$2

    { [ $# -ge 4 ] && _NVPAIRS=$3 && shift ; }

    _FREETEXT=$3

    eval _MSG_SLLVL=\${MSG_SLLVL_$_MSG_LEVEL}
    eval _MSG_SLNUM=\${MSG_SLNUM_$_MSG_LEVEL}

    local _CURLVL

    { [ -f $MSG_CUR_LVL ] && _CURLVL=`cat $MSG_CUR_LVL` ; } || _CURLVL=1

    if [ "$_MSG_LEVEL" != "D" ]; then
      echo "ota_install: $_MSG_LEVEL def:$_MSG_COMP:$_NVPAIRS:$_FREETEXT"
    fi
}

uninstall_previous()
{
	if [ -f "$INIT_DIR/$HACKNAME" ]; then
		logmsg "I" "update" "old jailbreak version found, uninstalling"
		# Remove old version of hack
		[ -d "$HOME_DIR/jailbreak" ] && rm -rf "$HOME_DIR/jailbreak"
		[ -f "$HOME_DIR/ENABLE_HACK_UPDATES" ] && rm -f "$HOME_DIR/ENABLE_HACK_UPDATES"
		rm -f "$KEY_DIR/pubprodkey01.hack.pem"
		rm -f "$KEY_DIR/pubprodkey02.hack.pem"
		rm -f "$KEY_DIR/pubprodkey01.amazon.pem"
		rm -f "$KEY_DIR/pubprodkey02.amazon.pem"
		rm -f "$INIT_DIR/$HACKNAME"
		for RC in 0 1 2 3 4 5 6
		do
		    rm -f "/mnt/main/etc/rc5.d/S${SLEVEL}${HACKNAME}"	
		    rm -f "/mnt/main/etc/rc3.d/K${KLEVEL}${HACKNAME}"	
		done
	fi
}

# mount prod. partition
if [ -d "/mnt/main" ]; then
 logmsg "E" "update" "/mnt/main is already exist, please check/remove"
 exit 1
fi
mkdir /mnt/main
mount -t ext3 -o rw /dev/mmcblk0p1 /mnt/main

# check if mount main partition
if [ -f "/mnt/main/opt/amazon/ebook/lib/booklet.jar" ]; then

	# Remove update provider hack if installed
	logmsg "I" "update" "removing old versions, if any"
	uninstall_previous

	logmsg "I" "update" "create jailbreak init script"
	cp -f jailbreak $INIT_DIR/$HACKNAME
	chmod a+x $INIT_DIR/$HACKNAME

	# relative links
	ln -fs ../init.d/${HACKNAME} /mnt/main/etc/rc5.d/S${SLEVEL}${HACKNAME}
	ln -fs ../init.d/${HACKNAME} /mnt/main/etc/rc3.d/K${KLEVEL}${HACKNAME}

	logmsg "I" "update" "copy the keys"
	cp -f pubprodkey01.hack.pem "$KEY_DIR/"

	sync
else
	logmsg "E" "update" "mount partition is unknow"
fi

umount /mnt/main
rm -r  /mnt/main
logmsg "I" "update" "done"

return 0
